// Includes.h : header file
//
// This file is a part of the XTREME CALENDAR MFC class library.
// (c)1998-2013 Codejock Software, All Rights Reserved.
//
// THIS SOURCE FILE IS THE PROPERTY OF CODEJOCK SOFTWARE AND IS NOT TO BE
// RE-DISTRIBUTED BY ANY MEANS WHATSOEVER WITHOUT THE EXPRESSED WRITTEN
// CONSENT OF CODEJOCK SOFTWARE.
//
// THIS SOURCE CODE CAN ONLY BE USED UNDER THE TERMS AND CONDITIONS OUTLINED
// IN THE XTREME TOOLKIT PRO LICENSE AGREEMENT. CODEJOCK SOFTWARE GRANTS TO
// YOU (ONE SOFTWARE DEVELOPER) THE LIMITED RIGHT TO USE THIS SOFTWARE ON A
// SINGLE COMPUTER.
//
// CONTACT INFORMATION:
// support@codejock.com
// http://www.codejock.com
//
/////////////////////////////////////////////////////////////////////////////

//{{AFX_CODEJOCK_PRIVATE
#if !defined(__XTPCALENDAR_INCLUDES_H__)
#define __XTPCALENDAR_INCLUDES_H__

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Resource.h"
#include "XTPCalendarDefines.h"

//----------------------------
// Xtreme DatePicker Control classes:
//----------------------------

#include "XTPDatePickerControl.h"
#include "XTPDatePickerDaysCollection.h"
#include "XTPDatePickerItemDay.h"
#include "XTPDatePickerItemMonth.h"
#include "XTPDatePickerList.h"
#include "XTPDatePickerNotifications.h"
#include "XTPDatePickerPaintManager.h"
#include "XTPDatePickerOffice2007Theme.h"
#include "XTPDatePickerOffice2013Theme.h"

//----------------------------
// Xtreme Calendar Control classes:
//----------------------------

#include "XTPCalendarUtils.h"
#include "XTPCalendarOptions.h"
#include "XTPCalendarNotifications.h"

#include "XTPCalendarPtrCollectionT.h"

#include "XTPCalendarTimeZoneHelper.h"

#include "XTPCalendarEvent.h"
#include "XTPCalendarEventLabel.h"
#include "XTPCalendarEvents.h"
#include "XTPCalendarRecurrencePattern.h"


#include "XTPCalendarView.h"
#include "XTPCalendarViewDay.h"
#include "XTPCalendarViewEvent.h"
#include "XTPCalendarViewPart.h"

#include "XTPCalendarDayViewEvent.h"
#include "XTPCalendarDayViewDay.h"
#include "XTPCalendarDayView.h"
#include "XTPCalendarDayViewTimeScale.h"

#include "XTPCalendarMonthViewEvent.h"
#include "XTPCalendarMonthViewDay.h"
#include "XTPCalendarMonthView.h"

#include "XTPCalendarWeekViewEvent.h"
#include "XTPCalendarWeekViewDay.h"
#include "XTPCalendarWeekView.h"

#include "XTPCalendarTimeLineView.h"

#include "XTPCalendarResource.h"
#include "XTPCalendarTip.h"

#include "XTPCalendarControl.h"
#include "XTPCalendarCaptionBarControl.h"
#include "XTPCalendarControlView.h"
#include "XTPCalendarController.h"

#include "XTPCalendarPaintManager.h"
#include "XTPCalendarTheme.h"
#include "XTPCalendarThemePrevNextEventButton.h"
#include "XTPCalendarThemePrevNextEventButtons.h"
#include "XTPCalendarThemeOffice2007.h"

#include "XTPCalendarRemindersManager.h"
#include "XTPCalendarResourcesManager.h"
#include "XTPCalendarCustomProperties.h"

#include "XTPCalendarOccurSeriesChooseDlg.h"
#include "XTPCalendarEventPropertiesDlg.h"
#include "XTPCalendarRemindersDialog.h"
#include "XTPCalendarEventRecurrenceDlg.h"

#include "XTPCalendarData.h"
#include "XTPCalendarMemoryDataProvider.h"

#endif // #if !defined(__XTPCALENDAR_INCLUDES_H__)

//}}AFX_CODEJOCK_PRIVATE
