#include "StdAfx.h"

#include <GraphicLibrary/unzip/unzip.h>
#include <Common/XTPMarkupTheme.h>

#include <Common/XTPDrawHelpers.h>
#include <Common/XTPResourceImage.h>
#include <Common/XTPHookManager.h>
#include <Common/XTPMarkupRender.h>
#include <Common/XTPResourceManager.h>
#include <Common/XTPSystemHelpers.h>
#include <Common/XTPColorManager.h>
#include <Common/XTPWinThemeWrapper.h>
#include <Common/XTPTheme.h>
#include <Common/XTPVC80Helpers.h>
#include <Common/ScrollBar/XTPScrollInfo.h>
#include <Common/Hook/XTPWinEventHook.h>

#include <CommandBars/XTPCommandBarsDefines.h>
#include <CommandBars/XTPCommandBar.h>
#include <CommandBars/XTPControls.h>
#include <CommandBars/XTPControl.h>
#include <CommandBars/XTPPaintManager.h>

#include <CommandBars/Frame/XTPFrameHook.h>
#include <CommandBars/Frame/XTPFramePaintManager.h>
#ifdef _XTP_INCLUDE_RIBBON
#include <Ribbon/XTPRibbonMarkupFrameTheme.h>
#endif
#include <CommandBars/Frame/XTPFrameThemeModernUI.h>
#include <CommandBars/Frame/XTPFrameThemeOffice2013.h>

#include <Markup/XTPMarkupObject.h>
#include <Markup/XTPMarkupDrawingContext.h>
#include <Markup/XTPMarkupInputElement.h>           // CXTPMarkupUIElement
#include <Markup/XTPMarkupUIElement.h>              // CXTPMarkupFrameworkElement
#include <Markup/XTPMarkupFrameworkElement.h>   // CXTPMarkupDecorator
#include <Markup/XTPMarkupDecorator.h>              // CXTPMarkupBorder
#include <Markup/XTPMarkupBorder.h>                 // CXTPMarkupBorder
#include <Markup/XTPMarkupPanel.h>                  // CXTPMarkupCanvas
#include <Markup/XTPMarkupCanvas.h>                 // CXTPMarkupCanvas
#include <Markup/XTPMarkupShape.h>                  // CXTPMarkupShape



CXTPFrameThemeOffice2013::CXTPFrameThemeOffice2013(CXTPPaintManager *pPaintManager)
	: CXTPFrameThemeModernUI(pPaintManager)
{
	m_rcIconMargin.SetRect(10,0,10,0);
	m_bFlatFrame = FALSE;

	m_clrFrameCaptionActive   = RGB(255, 255, 255);
	m_clrFrameCaptionInactive = RGB(255, 255, 255);

	m_bCaptionCenterAligned = TRUE;
}


CXTPFrameThemeOffice2013::~CXTPFrameThemeOffice2013()
{
}


void CXTPFrameThemeOffice2013::RefreshMetrics()
{
	CXTPFrameThemeModernUI::RefreshMetrics();

	m_nFrameCaptionHeight = 26;
}

LPCTSTR CXTPFrameThemeOffice2013::GetStyleResourceName() const
{
	return _T("XTP_IDR_OFFICE2013_STYLE");
}

CSize CXTPFrameThemeOffice2013::GetCaptionButtonSize(UINT nId) const
{
	UNUSED_ALWAYS(nId); // All buttons have the same size
	return CSize(29, 25);
}

CRect CXTPFrameThemeOffice2013::GetCaptionButtonMargin() const
{
	return CRect(0, 3, 0, 0);
}

CRect CXTPFrameThemeOffice2013::CalcFrameBorder(const CXTPCommandBarsFrameHook *pFrameHook) const
{
	ASSERT(NULL != pFrameHook);

	CRect rc = CXTPFrameThemeModernUI::CalcFrameBorder(pFrameHook);
	if (pFrameHook->IsMDIMaximized())
	{
		rc.top -= 4;
	}

	return rc;
}
