// Includes.h : header file
//
// This file is a part of the XTREME COMMANDBARS MFC class library.
// (c)1998-2013 Codejock Software, All Rights Reserved.
//
// THIS SOURCE FILE IS THE PROPERTY OF CODEJOCK SOFTWARE AND IS NOT TO BE
// RE-DISTRIBUTED BY ANY MEANS WHATSOEVER WITHOUT THE EXPRESSED WRITTEN
// CONSENT OF CODEJOCK SOFTWARE.
//
// THIS SOURCE CODE CAN ONLY BE USED UNDER THE TERMS AND CONDITIONS OUTLINED
// IN THE XTREME TOOLKIT PRO LICENSE AGREEMENT. CODEJOCK SOFTWARE GRANTS TO
// YOU (ONE SOFTWARE DEVELOPER) THE LIMITED RIGHT TO USE THIS SOFTWARE ON A
// SINGLE COMPUTER.
//
// CONTACT INFORMATION:
// support@codejock.com
// http://www.codejock.com
//
/////////////////////////////////////////////////////////////////////////////

//{{AFX_CODEJOCK_PRIVATE
#if !defined(__XTPCOMMANDBAR_INCLUDES_H__)
#define __XTPCOMMANDBAR_INCLUDES_H__

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Resource.h"

#include "XTPCommandBarsDefines.h"
#include "XTPCommandBarsOptions.h"
#include "XTPCommandBarList.h"
#include "XTPCommandBarsContextMenus.h"
#include "XTPCommandBars.h"
#include "XTPCommandBar.h"
#include "XTPCommandBarKeyboardTip.h"
#include "XTPToolBar.h"
#include "XTPPopupBar.h"
#include "XTPReBar.h"
#include "XTPMenuBar.h"
#include "MessageBar/XTPMessageBar.h"
#include "XTPDockBar.h"
#include "XTPDockContext.h"
#include "XTPDialogBar.h"
#include "XTPTabToolBar.h"
#include "XTPMiniToolBar.h"

#include "ScrollBar/XTPCommandBarScrollBarCtrl.h"

#include "XTPControls.h"
#include "XTPControl.h"
#include "XTPControlButton.h"
#include "XTPControlPopup.h"
#include "XTPControlEdit.h"
#include "XTPControlComboBox.h"
#include "XTPControlPopupColor.h"
#include "XTPControlComboBoxExt.h"
#include "XTPControlCustom.h"
#include "XTPControlListBox.h"
#include "XTPControlExt.h"
#include "XTPControlSlider.h"
#include "XTPControlScrollBar.h"
#include "XTPControlProgress.h"
#include "XTPControlGallery.h"
#include "XTPControlComboBoxGalleryPopupBar.h"

#include "XTPShortcutManager.h"
#include "XTPKeyboardManager.h"
#include "XTPMouseManager.h"

#include "XTPFrameWnd.h"
#include "XTPDialogBase.h"
#include "XTPImageEditor.h"
#include "XTPPreviewView.h"
#include "XTPPaintManager.h"

#if defined(_XTP_INCLUDE_TABMANAGER)
#include "XTPTabClientWnd.h"
#include <CommandBars/TabClient/NavigateButtonActiveFiles.h>
#include <CommandBars/TabClient/TabClientDropTarget.h>
#include <CommandBars/TabClient/Workspace.h>
#include <CommandBars/TabClient/SingleWorkspace.h>
#include <CommandBars/TabClient/XTPControlTabWorkspace.h>
#endif

#include <CommandBars/Customize/XTPCustomizePageCommands.h>
#include <CommandBars/Customize/XTPCustomizePageOptions.h>
#include <CommandBars/Customize/XTPCustomizePageKeyboard.h>
#include <CommandBars/Customize/XTPCustomizePageMenus.h>
#include <CommandBars/Customize/XTPCustomizePageToolbars.h>
#include <CommandBars/Customize/XTPCustomizeTools.h>
#include <CommandBars/Customize/XTPCustomizeSheet.h>

// Status bar
#include <CommandBars/StatusBar/XTPStatusBar.h>
#include <CommandBars/StatusBar/Panes/XTPStatusBarPane.h>
#include <CommandBars/StatusBar/Panes/XTPStatusBarPaneProgress.h>
#include <CommandBars/StatusBar/Panes/XTPStatusBarPaneScrollBar.h>
#include <CommandBars/StatusBar/Panes/XTPStatusBarPaneSlider.h>
#include <CommandBars/StatusBar/Panes/XTPStatusBarPaneSwitch.h>

// Frame
#include <CommandBars/Frame/XTPFrameHook.h>
#include <CommandBars/Frame/XTPFramePaintManager.h>

// Office
#include <CommandBars/Themes/XTPCommandBarsOffice2000Theme.h>
#include <CommandBars/Themes/XTPCommandBarsOfficeXPTheme.h>
#include <CommandBars/Themes/XTPCommandBarsOffice2003Theme.h>
#include <CommandBars/Themes/XTPCommandBarsResourceTheme.h>
#include <CommandBars/Themes/XTPCommandBarsThemeRibbon.h>

// Windows
#include <CommandBars/Themes/XTPCommandBarsNativeXPTheme.h>

// Visual Studio
#include <CommandBars/Themes/XTPCommandBarsVisualStudio6Theme.h>
#include <CommandBars/Themes/XTPCommandBarsVisualStudio2005Theme.h>
#include <CommandBars/Themes/XTPCommandBarsVisualStudio2008Theme.h>
#include <CommandBars/Themes/XTPCommandBarsVisualStudio2010Theme.h>

#include <CommandBars/Themes/XTPCommandBarsThemeMsMoney.h>

#include "XTPRecentFileList.h"

// Gallery
#include <CommandBars/Gallery/XTPControlGalleryItem.h>
#include <CommandBars/Gallery/XTPControlGalleryItems.h>
#include <CommandBars/Gallery/XTPGalleryListBox.h>


#endif //#if !defined(__XTPCOMMANDBAR_INCLUDES_H__)
//}}AFX_CODEJOCK_PRIVATE
